/* IMPLEMENTATION ARI... VERSION 0.0 OF 26.5.97 BY WH, WU-WIEN & BU-ISTANBUL*/
/* this file:   ari.c */
/* this is the implementation of algorithm ARI
   see the file ari.doc for more information.
version algo10_4 2.7.03 WH
*/

/*this is the structur for the parameters of the discrete distributions*/
typedef struct { double d1, d2, d3, d4;
                 long i1,i2,i3;   
	       }PARAM;

typedef struct{
       double vt, vc, vcr, xsq[2], y[2], ys[2], ac[2], pm, Hat[2];
       long int m, n[2], x[2], sign[2],s[2];
       double (*hh)(PARAM *param,long x);
       PARAM par;
     }TOTAL;

TOTAL *setup10_04(double (*hh)(PARAM *param,long x),PARAM *param,long m,long la,long ra,double pma);
/*hh....pointer to pmf, 
  param .... paramaters of pmf, 
  pma ... < 0 means pmf has sum 1; 
       pma>0 is the approximate mode probability as the sum of the pmf<>1
  m,la,ra...mode, smallest, largest number with probability>0*/

int generator10_04(TOTAL *t);
     /* calls the genrator */ 

int free10_04(TOTAL *t);
     /* frees the allocated memory */















